%define aurox_ver 10.1
%define rel 1


%define DRV_VERSION 0.9

%define kversion 2.6.9
%define krelver 10.1.aur.4
#define KVER %{kversion}-%{krelver}
#%if %(echo %{kernel} | grep -c smp)
#    {expand:%%define ksmp -smp}
#%endif
	


Summary: NdisWrapper allows you to use Windows XP drivers for that WLAN card without proper Linux drivers.
Name: ndiswrapper
Version: %{DRV_VERSION}
Release: %{aurox_ver}.aur.%{rel}
License: GPL
Group: System Environment/Base
URL: http://ndiswrapper.sourceforge.net
Source: %{name}-%{version}.tar.gz
Patch: ndiswrapper-0.7-make.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: kernel%{?ksmp} = %{kversion}-%{krelver}, kernel-source = %{kversion}-%{krelver}
BuildConflicts: rhbuildsys(DiskFree) < 250Mb


%description
Some wireless LAN vendors refuse to release hardware specifications or
drivers for their products for operating systems other than Microsoft
Windows. The ndiswrapper project makes it possible to use such
hardware with Linux by means of a loadable kernel module that "wraps
around" NDIS (Windows network driver API) drivers. This rpm contains
just the userspace tools. You will also need the kernel module rpm.

%package tools
Summary: NdisWrapper allows you to use Windows XP drivers for that WLAN card without proper Linux drivers.
Group: System Environment/Base
Obsoletes: ndiswrapper
Provides: ndiswrapper

%description tools
Some wireless LAN vendors refuse to release hardware specifications or
drivers for their products for operating systems other than Microsoft
Windows. The ndiswrapper project makes it possible to use such
hardware with Linux by means of a loadable kernel module that "wraps
around" NDIS (Windows network driver API) drivers. This rpm contains
just the userspace tools. You will also need the kernel module rpm.

%package kernel-%{kversion}-%{krelver}
Summary: NdisWrapper kernel module
Requires: kernel = %{kversion}-%{krelver}, ndiswrapper-tools = %{DRV_VERSION}
Release: %{release}
Group: System Environment/Kernel
PreReq: /sbin/depmod
Provides: kernel-modules
#%{?ksmp:Provides: ndiswrapper-kernel-%(name -r) = %{version}-%{release}_%{krelver}}

%description kernel-%{kversion}-%{krelver}
Kernel module for NdisWrapper.

%package kernel-smp-%{kversion}-%{krelver}
Summary: NdisWrapper SMP kernel module
Requires: kernel-smp = %{kversion}-%{krelver}, ndiswrapper-tools = %{DRV_VERSION}
Release: %{release}
Group: System Environment/Kernel
PreReq: /sbin/depmod
Provides: kernel-modules
Provides: ndiswrapper-kernel = %{kversion}-%{krelver}-%{DRV_VERSION}-%{release}

%description kernel-smp-%{kversion}-%{krelver}
SMP Kernel module for NdisWrapper.


%prep
%setup -q
%patch -p1

%build
BuildModule() {
	if [ -n "$1" ]; then
		Config=/usr/src/linux-%{kversion}-%{krelver}/configs/kernel-%{kversion}-%{_target_cpu}-$1.config
	else
%ifarch i386
# Since we only build userspace in this pass, the actual .config doesn't matter
		Config=/usr/src/linux-%{kversion}-%{krelver}/configs/kernel-%{kversion}-i686.config
%else
		Config=/usr/src/linux-%{kversion}-%{krelver}/configs/kernel-%{kversion}-%{_target_cpu}.config
%endif
	fi
	cp -f $Config %{_tmppath}/linux-%{kversion}-%{krelver}/.config
	# Make sure version matches
	perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krelver}$1/" %{_tmppath}/linux-%{kversion}-%{krelver}/Makefile
	make -C %{_tmppath}/linux-%{kversion}-%{krelver} nonint_oldconfig 1>/dev/null
	make -C %{_tmppath}/linux-%{kversion}-%{krelver} prepare-all
	make KVER=%{kversion}-%{krelver}$1 KSRC=%{_tmppath}/linux-%{kversion}-%{krelver} all
}

# This is absolutely wrong, change to cp -af if it doesn't work
cp -alf /usr/src/linux-%{kversion}-%{krelver} %{_tmppath}
cp -f /lib/modules/%{kversion}-%{krelver}/build/include/linux/version.h %{_tmppath}/linux-%{kversion}-%{krelver}/include/linux
# See if SMP config is available: we want to build both SMP and UP modules for 
# a given architecture in one pass if possible.
if [ -f /usr/src/linux-%{kversion}-%{krelver}/configs/kernel-%{kversion}-%{_target_cpu}-smp.config ]; then
	BuildModule smp
	mv driver/ndiswrapper.ko driver/ndiswrapper-smp.ko
fi
BuildModule

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8
make KVER=%{kversion}-%{krelver} KSRC=%{_tmppath}/linux-%{kversion}-%{krelver} INST_DIR=$RPM_BUILD_ROOT/lib/modules/%{kversion}-%{krelver}/misc DESTDIR=$RPM_BUILD_ROOT install
# the module needs to be stripped anyway, so make it executable
install -D driver/ndiswrapper.ko $RPM_BUILD_ROOT/lib/modules/%{kversion}-%{krelver}/misc/ndiswrapper.ko
# install the SMP module
if [ -f driver/ndiswrapper-smp.ko ]; then
	install -D driver/ndiswrapper-smp.ko $RPM_BUILD_ROOT/lib/modules/%{kversion}-%{krelver}smp/misc/ndiswrapper.ko
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf %{_tmppath}/linux-%{kversion}-%{krelver}

# This is hackish but rpmbuild won't accept arch-conditional subpackages
%ifarch i386
%files tools
%undefine __check_files
%defattr(0755,root,root)
/sbin/loadndisdriver
/usr/sbin/ndiswrapper
/usr/sbin/wlan_radio_averatec_5110hx
/usr/share/man/man8/ndiswrapper.8.gz
%doc README AUTHORS ChangeLog INSTALL
%endif

%ifnarch i386
%files kernel-%{kversion}-%{krelver}
%undefine __check_files
%defattr(0644,root,root)
/lib/modules/%{kversion}-%{krelver}/misc/ndiswrapper.*
%ifnarch i586 # no SMP modules for those
%files kernel-smp-%{kversion}-%{krelver}
%undefine __check_files
%defattr(0644,root,root)
/lib/modules/%{kversion}-%{krelver}smp/misc/ndiswrapper.*
%endif # i586
%endif # i386

%post kernel-%{kversion}-%{krelver}
/sbin/depmod -a

%post kernel-smp-%{kversion}-%{krelver}
/sbin/depmod -a


%postun kernel-%{kversion}-%{krelver}
/sbin/depmod -a

%postun kernel-smp-%{kversion}-%{krelver}
/sbin/depmod -a


%changelog
* Fri Nov 12 2004 Aurox Team <aurox@aurox.org> 0:0.9-10.1.aur.1
- Respin against 2.6.9-10.1.aur.4.
- Respin against 2.6.9-10.1.aur.1.
- Update to ndiswrapper-0.9, respin against 2.6.7-10.0.aur.9.
- Make the module build for UP and SMP kernels.
- Upgrade to ndiswrapper-0.8
- Split into -tools and -kernel so modules can be built for multiple architectures
- Respin against kernel-2.6.7-10.0.aur.4
- fix installing of module and utils
- initial import

* Tue Feb  3 2004  <abennett@olin.edu> - 
- Initial build.

